"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Bar =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Bar, _React$Component);

  function Bar() {
    _classCallCheck(this, Bar);

    return _possibleConstructorReturn(this, _getPrototypeOf(Bar).apply(this, arguments));
  }

  _createClass(Bar, [{
    key: "render",
    value: function render() {
      var _this = this;

      var bars = [];
      var limit = 5;
      var _this$props$data = this.props.data,
          c = _this$props$data.c,
          name = _this$props$data.name,
          key = _this$props$data.key,
          stack = _this$props$data.stack;

      if (this.props.group) {
        var highlights = _lodash["default"].chain(stack).sortBy('c').reverse().slice(0, limit).map('key').value();

        var amount = c;

        _lodash["default"].mapValues(stack, function (bar) {
          if (highlights.includes(bar.key)) {
            amount -= bar.c;
            var proportion = _this.props.max > 0 ? bar.c / _this.props.max : 0;
            var width = "".concat(proportion * 100, "%");
            bars.push(_react["default"].createElement("div", {
              key: bar.key + _this.props.group,
              title: "".concat(bar.name, ": ").concat((0, _utils.numberFormat)(bar.c), " (").concat((bar.c / c * 100).toFixed(3), "%)"),
              className: "bar-graph__bar",
              style: {
                width: width,
                backgroundColor: _this.props.getColor(bar.key, _this.props.group)
              }
            }));
          }
        });

        if (amount > 0) {
          var percentage = this.props.max > 0 ? amount / this.props.max * 100 : 0;
          var width = "".concat(percentage, "%");
          bars.push(_react["default"].createElement("div", {
            title: "others: ".concat((0, _utils.numberFormat)(amount), ", (").concat((amount / c * 100).toFixed(3), "%)"),
            key: 'others' + this.props.group,
            className: "bar-graph__bar",
            style: {
              width: width,
              backgroundColor: this.props.getColor('other')
            }
          }));
        }
      } else {
        var _percentage = this.props.max > 0 ? c / this.props.max * 100 : 0;

        var _width = "".concat(_percentage, "%");

        bars.push(_react["default"].createElement("div", {
          title: "".concat(name, ": ").concat((0, _utils.numberFormat)(c)),
          key: key,
          className: "bar-graph__bar",
          style: {
            width: _width,
            backgroundColor: this.props.getColor(key)
          }
        }));
      }

      return _react["default"].createElement("div", {
        className: "bar-graph__bar-wrap"
      }, bars, _react["default"].createElement("span", {
        className: "bar-graph__bar__percentage"
      }, "".concat((this.props.proportion * 100).toFixed(3), "%")));
    }
  }]);

  return Bar;
}(_react["default"].Component);

exports["default"] = Bar;

_defineProperty(Bar, "propTypes", {
  data: _propTypes["default"].object,
  max: _propTypes["default"].number,
  group: _propTypes["default"].string,
  getColor: _propTypes["default"].func,
  name: _propTypes["default"].string,
  proportion: _propTypes["default"].number
});