"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _map2 = _interopRequireDefault(require("lodash/map"));

var _mapValues2 = _interopRequireDefault(require("lodash/mapValues"));

var _size2 = _interopRequireDefault(require("lodash/size"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBootstrap = require("react-bootstrap");

var _utils = require("../utils");

var _bar_graph_header = _interopRequireDefault(require("./bar_graph_header"));

var _bar_list = _interopRequireDefault(require("./bar_list"));

require("../style/BarGraph.scss");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var BarGraph =
/*#__PURE__*/
function (_React$Component) {
  _inherits(BarGraph, _React$Component);

  function BarGraph() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, BarGraph);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(BarGraph)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      stretched: false,
      search: null
    });

    _defineProperty(_assertThisInitialized(_this), "onSearch", function (e) {
      var search = e.target.value;

      if (search.length) {
        try {
          new RegExp(search, 'i');

          _this.setState({
            search: search
          });
        } catch (e) {
          _this.setState({
            search: false
          });
        }
      } else {
        _this.setState({
          search: null
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onStretch", function () {
      _this.setState({
        stretched: !_this.state.stretched
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onChange", function (name, selected) {
      return _this.props.onChange && _this.props.onChange(name, selected);
    });

    return _this;
  }

  _createClass(BarGraph, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var dimension = (0, _utils.normalizeData)(this.props.data, this.props.lookup[this.props.name], this.props.lookup[this.props.group]);
      var allData = (0, _mapValues2["default"])(this.props.allData, function (data, name) {
        return (0, _utils.normalizeData)(data, _this2.props.lookup[name], _this2.props.lookup[_this2.props.group]);
      });
      var comparing = this.props.comparingTo ? (0, _utils.normalizeData)(this.props.comparingTo, this.props.lookup[this.props.name], this.props.lookup[this.props.group]) : null;
      var filter = this.state.search;
      var isGroupSource = this.props.group && this.props.group === this.props.name;
      return _react["default"].createElement(_reactBootstrap.Panel, {
        bsStyle: isGroupSource ? 'info' : 'default',
        className: "bar-graph__container"
      }, _react["default"].createElement(_reactBootstrap.Panel.Heading, null, _react["default"].createElement(_bar_graph_header["default"], {
        name: this.props.name,
        description: this.props.description,
        dimensions: (0, _map2["default"])(dimension.serie, 'key'),
        total: dimension.total,
        comparingTo: comparing && comparing.serie,
        dimension: dimension.serie,
        selectedItems: this.props.selected,
        onSearch: this.onSearch,
        filter: filter,
        size: (0, _size2["default"])(dimension.serie),
        onStretch: !isGroupSource && this.onStretch,
        stretched: !isGroupSource && this.state.stretched,
        onChange: this.onChange,
        slice: this.props.slice,
        group: this.props.group,
        allData: allData
      })), _react["default"].createElement(_reactBootstrap.Panel.Body, null, filter ? _react["default"].createElement("div", {
        className: "bar-graph__search-help"
      }, "Search result for \"", filter, "\"") : null, _react["default"].createElement(_bar_list["default"], {
        name: this.props.name,
        dimension: dimension,
        filter: filter,
        comparingTo: comparing,
        group: this.props.group,
        stretched: this.state.stretched,
        lookup: this.props.lookup,
        selected: this.props.selected,
        onChange: this.onChange,
        slice: this.props.slice,
        getColor: this.props.getColor
      })));
    }
  }]);

  return BarGraph;
}(_react["default"].Component);

exports["default"] = BarGraph;

_defineProperty(BarGraph, "propTypes", {
  comparingTo: _propTypes["default"].object,
  data: _propTypes["default"].object,
  getColor: _propTypes["default"].func,
  group: _propTypes["default"].string,
  lookup: _propTypes["default"].object,
  name: _propTypes["default"].string.isRequired,
  description: _propTypes["default"].string,
  onChange: _propTypes["default"].func,
  selected: _propTypes["default"].array
});

_defineProperty(BarGraph, "defaultProps", {
  name: '',
  group: null,
  selected: [],
  comparingTo: null,
  lookup: {}
});