"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _each2 = _interopRequireDefault(require("lodash/each"));

var _map2 = _interopRequireDefault(require("lodash/map"));

var _difference2 = _interopRequireDefault(require("lodash/difference"));

var _size2 = _interopRequireDefault(require("lodash/size"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBootstrap = require("react-bootstrap");

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var BarGraphHeader =
/*#__PURE__*/
function (_React$Component) {
  _inherits(BarGraphHeader, _React$Component);

  function BarGraphHeader() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, BarGraphHeader);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(BarGraphHeader)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "onDownload", function (dataLabel, volume, dataSerie, comparingTo) {
      return function () {
        var defaultDimension = {
          c: 0
        };
        var stacksLabel = '';
        var delimiter = ',';
        var endLine = '\r\n';

        var createLine = function createLine(name) {
          var count = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
          var stack = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
          var proportion = volume > 0 && count > 0 ? (count || 0) / volume : 0;
          var stacks = '';

          if (_this.props.group) {
            (0, _each2["default"])(_this.props.allData[_this.props.group].serie, function (d, i) {
              stacks += "".concat(delimiter).concat((stack[i] || defaultDimension).c);
            });
          }

          stacks += "".concat(delimiter).concat(count);
          return "".concat(name).concat(delimiter).concat((proportion * 100).toFixed(3), "%").concat(stacks).concat(endLine);
        };

        var body = (0, _map2["default"])(dataSerie, function (el) {
          if (comparingTo) {
            var window = comparingTo[el.key] || {
              count: 0,
              stack: []
            };
            return "".concat(createLine("".concat(el.name).concat(delimiter, "A"), window.c, window.stack)).concat(createLine("".concat(el.name).concat(delimiter, "B"), el.c, el.stack));
          } else {
            return createLine(el.name, el.c, el.stack);
          }
        }).join('');

        if (_this.props.group) {
          (0, _each2["default"])(_this.props.allData[_this.props.group].serie, function (d, i) {
            stacksLabel += "".concat(delimiter).concat(d.name || i);
          });
        }

        stacksLabel += "".concat(delimiter, "event count");
        var header = "".concat(dataLabel).concat(delimiter).concat(comparingTo ? "window".concat(delimiter) : '', "percentage").concat(stacksLabel).concat(endLine);
        var fileData = header + body;
        var blob = new Blob([fileData], {
          type: 'text/plain'
        });
        (0, _utils.saveData)("event_".concat(_this.props.name, "_serie_").concat(dataLabel).concat(_this.props.group ? "_grouped_by_".concat(_this.props.group) : '', ".csv"), blob);
      };
    });

    _defineProperty(_assertThisInitialized(_this), "onClickAddAll", function (e) {
      e.preventDefault();

      _this.props.onChange(_this.props.name, (0, _difference2["default"])(_this.props.dimensions, _this.props.selectedItems));
    });

    _defineProperty(_assertThisInitialized(_this), "onClickInvert", function (e) {
      e.preventDefault();

      _this.props.onChange(_this.props.name, _this.props.dimensions);
    });

    _defineProperty(_assertThisInitialized(_this), "onClickRemoveAll", function (e) {
      e.preventDefault();

      _this.props.onChange(_this.props.name, _this.props.selectedItems);
    });

    return _this;
  }

  _createClass(BarGraphHeader, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var name = this.props.description ? _react["default"].createElement(_reactBootstrap.OverlayTrigger, {
        placement: "top",
        overlay: _react["default"].createElement(_reactBootstrap.Tooltip, {
          id: this.props.name
        }, this.props.description)
      }, _react["default"].createElement("span", null, this.props.name)) : this.props.name;
      return _react["default"].createElement("div", null, _react["default"].createElement("h4", null, name, ' ', _react["default"].createElement("small", null, "(", (this.props.slice && this.props.slice < this.props.size ? "".concat(this.props.slice, " of ") : '') + this.props.size, ")")), _react["default"].createElement(_reactBootstrap.ButtonGroup, {
        className: "bar-graph__actions"
      }, _react["default"].createElement(_reactBootstrap.Button, {
        title: "Click to save as csv",
        onClick: this.onDownload(this.props.name, this.props.total, this.props.dimension, this.props.comparingTo)
      }, _react["default"].createElement(_reactBootstrap.Glyphicon, {
        glyph: "save"
      })), _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_reactBootstrap.OverlayTrigger, {
        trigger: "click",
        rootClose: true,
        placement: "bottom",
        overlay: _react["default"].createElement(_reactBootstrap.Popover, {
          className: "bar-graph__filter__dimension",
          id: "popover-".concat(this.props.name),
          title: ""
        }, _react["default"].createElement("div", null, _react["default"].createElement(_reactBootstrap.ButtonGroup, null, _react["default"].createElement(_reactBootstrap.Button, {
          bsSize: "small",
          bsStyle: "primary",
          onClick: this.onClickAddAll
        }, "Add all"), _react["default"].createElement(_reactBootstrap.Button, {
          bsSize: "small",
          bsStyle: "primary",
          onClick: this.onClickInvert,
          disabled: !(0, _size2["default"])(this.props.selectedItems)
        }, "Invert selected"), _react["default"].createElement(_reactBootstrap.Button, {
          bsSize: "small",
          bsStyle: "primary",
          onClick: this.onClickRemoveAll,
          disabled: !(0, _size2["default"])(this.props.selectedItems)
        }, "Remove all"))), _react["default"].createElement("br", null), _react["default"].createElement("div", null, _react["default"].createElement(_reactBootstrap.FormGroup, {
          className: "bar-graph__list__search",
          bsSize: "small",
          validationState: this.props.filter === false ? 'error' : this.props.filter ? 'success' : null
        }, _react["default"].createElement(_reactBootstrap.FormControl, {
          defaultValue: this.props.filter ? this.props.filter : undefined,
          onChange: this.props.onSearch,
          placeholder: "Looking for...",
          type: "text"
        }), _react["default"].createElement(_reactBootstrap.FormControl.Feedback, null, _react["default"].createElement(_reactBootstrap.Glyphicon, {
          glyph: "search"
        })))), _react["default"].createElement("br", null), _react["default"].createElement("div", null, _react["default"].createElement(_reactBootstrap.ButtonToolbar, null, (0, _map2["default"])(this.props.selectedItems, function (f) {
          return _react["default"].createElement(_reactBootstrap.Button, {
            className: "bar-graph__filter__dimension__button",
            key: "filter-".concat(f),
            onClick: function onClick() {
              _this2.props.onChange(_this2.props.name, f);
            },
            bsSize: "xsmall"
          }, f, " ", _react["default"].createElement(_reactBootstrap.Glyphicon, {
            glyph: "remove-sign"
          }));
        }))), ' ')
      }, _react["default"].createElement(_reactBootstrap.Button, {
        title: "Click to change the applied filters",
        bsStyle: (this.props.selectedItems || this.props.filter || []).length ? 'info' : 'default'
      }, _react["default"].createElement(_reactBootstrap.Glyphicon, {
        glyph: "filter"
      })))), this.props.onStretch ? _react["default"].createElement(_reactBootstrap.Button, {
        title: "Click to change the view mode",
        bsStyle: this.props.stretched ? 'primary' : 'default',
        onClick: this.props.onStretch
      }, _react["default"].createElement(_reactBootstrap.Glyphicon, {
        glyph: "tasks"
      })) : null, _react["default"].createElement(_reactBootstrap.Button, {
        title: "Click to change the stacking based in this group",
        bsStyle: this.props.group === this.props.name ? 'primary' : 'default',
        onClick: function onClick() {
          _this2.props.onChange('group', _this2.props.name);
        }
      }, _react["default"].createElement(_reactBootstrap.Glyphicon, {
        glyph: "indent-left"
      }))));
    }
  }]);

  return BarGraphHeader;
}(_react["default"].Component);

exports["default"] = BarGraphHeader;

_defineProperty(BarGraphHeader, "propTypes", {
  allData: _propTypes["default"].object,
  comparingTo: _propTypes["default"].object,
  dimension: _propTypes["default"].object,
  dimensions: _propTypes["default"].array,
  selectedItems: _propTypes["default"].array,
  filter: _propTypes["default"].string,
  group: _propTypes["default"].string,
  name: _propTypes["default"].string.isRequired,
  description: _propTypes["default"].string,
  size: _propTypes["default"].number,
  slice: _propTypes["default"].number,
  total: _propTypes["default"].number,
  stretched: _propTypes["default"].bool,
  onChange: _propTypes["default"].func,
  onSearch: _propTypes["default"].func,
  onStretch: _propTypes["default"].func
});