"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = require("../utils");

var _bar = _interopRequireDefault(require("./bar"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var BarLine =
/*#__PURE__*/
function (_React$Component) {
  _inherits(BarLine, _React$Component);

  function BarLine() {
    _classCallCheck(this, BarLine);

    return _possibleConstructorReturn(this, _getPrototypeOf(BarLine).apply(this, arguments));
  }

  _createClass(BarLine, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      return true;
    }
  }, {
    key: "getIcon",
    value: function getIcon(val1, val2) {
      var percentage = (Math.abs(1 - val1 / val2) * 100).toFixed(1);

      if (val1 > val2) {
        return _react["default"].createElement("div", {
          className: "bar-graph__variation__wrapper"
        }, _react["default"].createElement("span", {
          className: "bar-graph__variation--up"
        }, '▲', isFinite(percentage) ? _react["default"].createElement("span", {
          className: "variation__icon"
        }, "".concat(percentage, "% ")) : _react["default"].createElement("span", {
          className: "variation__icon--infinity"
        }, "\u221E")));
      } else if (val2 > val1) {
        return _react["default"].createElement("div", {
          className: "bar-graph__variation__wrapper"
        }, _react["default"].createElement("span", {
          className: "bar-graph__variation--down"
        }, '▼', isFinite(percentage) ? _react["default"].createElement("span", {
          className: "variation__icon"
        }, "".concat(percentage, "% ")) : _react["default"].createElement("span", {
          className: "variation__icon--infinity"
        }, "\u221E")));
      }

      return _react["default"].createElement("div", {
        className: "bar-graph__variation__wrapper"
      }, _react["default"].createElement("span", {
        className: "bar-graph__variation"
      }, '='));
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      return _react["default"].createElement("div", {
        className: 'bar-graph' + (this.props.selected ? ' selected' : ''),
        onClick: function onClick() {
          return _this.props.onChange(_this.props.name, _this.props.data.key);
        }
      }, this.props.comparingData ? this.getIcon(this.props.data.c, this.props.comparingData.c) : null, _react["default"].createElement("div", {
        className: "bar-graph__label__wrapper"
      }, _react["default"].createElement("div", {
        className: "bar-graph__label"
      }, this.props.label)), this.props.comparingData ? _react["default"].createElement("div", {
        className: "bar-graph__value__wrapper"
      }, _react["default"].createElement("div", {
        className: 'bar-graph__value'
      }, (0, _utils.numberFormat)(this.props.comparingData.c || 0)), _react["default"].createElement("div", {
        className: 'bar-graph__value'
      }, (0, _utils.numberFormat)(this.props.data.c || 0))) : _react["default"].createElement("div", {
        className: "bar-graph__value__wrapper"
      }, _react["default"].createElement("div", {
        className: "bar-graph__value"
      }, (0, _utils.numberFormat)(this.props.data.c || 0))), _react["default"].createElement("div", {
        className: "bar-graph__bar-container__wrapper"
      }, _react["default"].createElement("div", {
        className: "bar-graph__bar-container"
      }, this.props.comparingData ? _react["default"].createElement(_bar["default"], {
        key: "comparing",
        container: this.props.container,
        data: this.props.comparingData,
        group: this.props.group,
        name: this.props.name,
        max: this.props.stretched ? this.props.comparingData.c : this.props.max,
        getColor: this.props.getColor,
        proportion: this.props.comparingTotal > 0 && this.props.comparingData.c > 0 ? (this.props.comparingData.c || 0) / this.props.comparingTotal : 0
      }) : null, _react["default"].createElement(_bar["default"], {
        container: this.props.container,
        data: this.props.data,
        group: this.props.group,
        name: this.props.name,
        max: this.props.stretched ? this.props.data.c : this.props.max,
        getColor: this.props.getColor,
        proportion: this.props.total > 0 && this.props.data.c > 0 ? (this.props.data.c || 0) / this.props.total : 0
      }))));
    }
  }]);

  return BarLine;
}(_react["default"].Component);

exports["default"] = BarLine;

_defineProperty(BarLine, "propTypes", {
  onChange: _propTypes["default"].func,
  container: _propTypes["default"].any,
  data: _propTypes["default"].object,
  getColor: _propTypes["default"].func,
  group: _propTypes["default"].string,
  label: _propTypes["default"].string,
  max: _propTypes["default"].number,
  selected: _propTypes["default"].bool,
  name: _propTypes["default"].any,
  stretched: _propTypes["default"].bool,
  total: _propTypes["default"].number,
  comparingData: _propTypes["default"].any,
  comparingTotal: _propTypes["default"].number
});