"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _map2 = _interopRequireDefault(require("lodash/map"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _d = require("d3");

var _d3Scale = require("d3-scale");

var _utils = require("../utils");

var _bar_line = _interopRequireDefault(require("./bar_line"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var BarList =
/*#__PURE__*/
function (_React$Component) {
  _inherits(BarList, _React$Component);

  function BarList() {
    _classCallCheck(this, BarList);

    return _possibleConstructorReturn(this, _getPrototypeOf(BarList).apply(this, arguments));
  }

  _createClass(BarList, [{
    key: "render",
    // shouldComponentUpdate(){
    //   return true;
    // }
    value: function render() {
      var _this = this;

      var _this$props$dimension = this.props.dimension,
          serie = _this$props$dimension.serie,
          max = _this$props$dimension.max,
          total = _this$props$dimension.total;

      if (!(0, _isEmpty2["default"])(serie)) {
        var comparingMax = this.props.comparingTo ? this.props.comparingTo.max : 0;
        var prefix = this.props.hideCommonPrefix ? (0, _utils.getCommonPrefix)((0, _map2["default"])(this.props.data, function (d) {
          if (d.name !== '<not defined>') return d.name;
        })) : '';
        return _react["default"].createElement("div", {
          className: "cube_bars__list__content"
        }, (0, _lodash["default"])(serie).sortBy('c').reverse().filter(function (d) {
          return !_this.props.filter || RegExp(_this.props.filter, 'i').test(d.name);
        }).slice(0, this.props.slice || serie.length).map(function (d) {
          var comparingData = null;

          if (_this.props.comparingTo && _this.props.comparingTo.serie) {
            comparingData = _this.props.comparingTo.serie[d.key] ? _this.props.comparingTo.serie[d.key] : {
              c: 0
            };
          }

          return _react["default"].createElement(_bar_line["default"], {
            key: d.key,
            name: _this.props.name,
            label: prefix ? d.name.startsWith(prefix) ? d.name.substring(prefix.length) : d.name : d.name,
            total: total,
            comparingTotal: _this.props.comparingTo ? _this.props.comparingTo.total : null,
            max: Math.max(max, comparingMax),
            data: d,
            group: _this.props.group,
            stretched: _this.props.stretched,
            container: _this,
            onChange: _this.props.onChange,
            comparingData: comparingData,
            getColor: _this.props.getColor,
            selected: _this.props.selected.indexOf(d.key) >= 0
          });
        }).value());
      }

      return _react["default"].createElement("div", {
        className: "cube_bars__list__content--empty"
      }, "No dimension available");
    }
  }]);

  return BarList;
}(_react["default"].Component);

exports["default"] = BarList;

_defineProperty(BarList, "propTypes", {
  dimension: _propTypes["default"].object,
  slice: _propTypes["default"].number,
  hideCommonPrefix: _propTypes["default"].bool,
  stretched: _propTypes["default"].bool,
  filter: _propTypes["default"].string,
  getColor: _propTypes["default"].func,
  group: _propTypes["default"].string,
  name: _propTypes["default"].string,
  comparingTo: _propTypes["default"].object,
  lookup: _propTypes["default"].object,
  selected: _propTypes["default"].array
});

_defineProperty(BarList, "defaultProps", {
  hideCommonPrefix: false,
  stretched: false,
  getColor: (0, _d3Scale.scaleOrdinal)(_d.schemePaired)
});