"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _map2 = _interopRequireDefault(require("lodash/map"));

var _react = _interopRequireDefault(require("react"));

var _BarGraph = _interopRequireDefault(require("../BarGraph"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var BarGraphColumn =
/*#__PURE__*/
function (_React$Component) {
  _inherits(BarGraphColumn, _React$Component);

  function BarGraphColumn(props) {
    var _this;

    _classCallCheck(this, BarGraphColumn);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(BarGraphColumn).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "onStretch", function (serie) {
      return function () {
        _this.setState({
          stretched: Object.assign({}, _this.state.stretched, _defineProperty({}, _this.props.name + serie, !_this.state.stretched[_this.props.name + serie]))
        });
      };
    });

    _defineProperty(_assertThisInitialized(_this), "onSearch", function (serie) {
      return function (e) {
        var search = e.target.value;

        if (search.length) {
          try {
            new RegExp(search, 'i');

            _this.setState({
              search: Object.assign({}, _this.state.search, _defineProperty({}, serie, search))
            });
          } catch (e) {
            _this.setState({
              search: Object.assign({}, _this.state.search, _defineProperty({}, serie, false))
            });
          }
        } else {
          _this.setState({
            search: Object.assign({}, _this.state.search, _defineProperty({}, serie, undefined))
          });
        }
      };
    });

    _this.state = {
      stretched: [],
      search: []
    };
    return _this;
  }

  _createClass(BarGraphColumn, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react["default"].createElement("div", {
        className: "cube_graph__column"
      }, (0, _map2["default"])(this.props.data, function (serie, key) {
        var description = _this2.props.dataDescription ? _this2.props.dataDescription[key] : undefined;
        return _react["default"].createElement("div", {
          key: key,
          className: 'bar-graph-group__list'
        }, _react["default"].createElement(_BarGraph["default"], {
          name: key,
          description: description,
          data: serie,
          comparingTo: _this2.props.comparingTo && _this2.props.comparingTo[key],
          selected: _this2.props.selectedItems && _this2.props.selectedItems[key],
          onChange: _this2.props.onChange,
          slice: _this2.props.slice,
          group: _this2.props.group,
          lookup: _this2.props.lookup,
          getColor: _this2.props.getColor,
          allData: _this2.props.allData
        }));
      }));
    }
  }]);

  return BarGraphColumn;
}(_react["default"].Component);

exports["default"] = BarGraphColumn;