"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _d = require("d3");

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _bar_graph_column = _interopRequireDefault(require("./bar_graph_column"));

require("../style/BarGraphGroup.scss");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var BarGraphGroup =
/*#__PURE__*/
function (_React$Component) {
  _inherits(BarGraphGroup, _React$Component);

  function BarGraphGroup() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, BarGraphGroup);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(BarGraphGroup)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "getColumns", function () {
      return _this.props.columns || Math.floor(_this.props.width / 420);
    });

    return _this;
  }

  _createClass(BarGraphGroup, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var n = 0;
      var content = (0, _lodash["default"])(this.props.data).toPairs().sortBy(function (p) {
        var index = _this2.props.fieldOrders.indexOf(p[0]);

        if (index < 0) return 99999;else return index;
      }).groupBy(function () {
        return n++ % _this2.getColumns();
      }).map(function (g) {
        var key = _lodash["default"].reduce(g, function (k, e) {
          return k + e[0];
        });

        return _react["default"].createElement(_bar_graph_column["default"], {
          key: key,
          data: _lodash["default"].fromPairs(g),
          dataDescription: _this2.props.dataDescription,
          allData: _this2.props.data,
          comparingTo: _this2.props.comparingTo,
          lookup: _this2.props.lookup,
          group: _this2.props.group,
          onChange: _this2.props.onChange,
          slice: _this2.props.slice,
          selectedItems: _this2.props.selectedItems,
          getColor: _this2.props.getColor
        });
      }).value();
      return _react["default"].createElement("div", {
        className: "bar-graph-group"
      }, content);
    }
  }]);

  return BarGraphGroup;
}(_react["default"].Component);

exports["default"] = BarGraphGroup;

_defineProperty(BarGraphGroup, "propTypes", {
  slice: _propTypes["default"].number,
  width: _propTypes["default"].number,
  columns: _propTypes["default"].number,
  onChange: _propTypes["default"].func,
  data: _propTypes["default"].object.isRequired,
  dataDescription: _propTypes["default"].object,
  fieldOrders: _propTypes["default"].array,
  getColor: _propTypes["default"].func,
  group: _propTypes["default"].string,
  lookup: _propTypes["default"].object,
  selectedItems: _propTypes["default"].object,
  comparingTo: _propTypes["default"].object
});

_defineProperty(BarGraphGroup, "defaultProps", {
  onChange: undefined,
  data: {},
  fieldOrders: [],
  getColor: (0, _d.scaleOrdinal)(_d.schemePaired),
  group: null,
  lookup: {},
  selectedItems: {},
  width: 420,
  comparingTo: null,
  columns: null
});