"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBootstrap = require("react-bootstrap");

require("./style/TagGroup.scss");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var TagGroup =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TagGroup, _React$Component);

  function TagGroup() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, TagGroup);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(TagGroup)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "onClick", function (dimension, value) {
      return function () {
        _this.props.onChange && _this.props.onChange(dimension, value);
      };
    });

    return _this;
  }

  _createClass(TagGroup, [{
    key: "lookup",
    value: function lookup(k, d) {
      return this.props.lookup && this.props.lookup[k] && this.props.lookup[k][d] || d;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var filterEl = [];
      var _this$props = this.props,
          tags = _this$props.tags,
          getColor = _this$props.getColor,
          onChange = _this$props.onChange;

      _lodash["default"].map(tags, function (f, dimension) {
        _lodash["default"].map(f, function (value, i) {
          var text = null;
          var iconEl = null;

          if (getColor) {
            iconEl = _react["default"].createElement("span", {
              className: "graph-tags__element__color",
              style: {
                backgroundColor: _this2.props.getColor(text, dimension)
              }
            });
          } else {
            iconEl = _react["default"].createElement("span", {
              className: "graph-tags__element__icon"
            }, _react["default"].createElement(_reactBootstrap.Glyphicon, {
              glyph: "filter"
            }));
          }

          if (_lodash["default"].isObject(value)) {
            if (value.text) text = value.text;
            if (value.icon) iconEl = _react["default"].createElement("span", {
              className: "graph-tags__element__icon"
            }, value.icon);
          } else {
            text = value;
          }

          filterEl.push(_react["default"].createElement("span", {
            className: "graph-tags__element ".concat(_lodash["default"].isUndefined(onChange) ? "" : "graph-tags__element--with-action"),
            key: "filter-" + dimension + text + i,
            onClick: _this2.onClick(dimension, text)
          }, iconEl, " ", dimension, ": ", _this2.lookup(dimension, text)));
        });
      });

      return _react["default"].createElement("div", {
        className: "graph-tags"
      }, filterEl);
    }
  }]);

  return TagGroup;
}(_react["default"].Component);

exports["default"] = TagGroup;

_defineProperty(TagGroup, "propTypes", {
  lookup: _propTypes["default"].object,
  onChange: _propTypes["default"].func,
  getColor: _propTypes["default"].func,
  tags: _propTypes["default"].object
});