"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.aggregation = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var d3 = _interopRequireWildcard(require("d3"));

var _reactFauxDom = _interopRequireDefault(require("react-faux-dom"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _TimeGraphContent = _interopRequireDefault(require("./TimeGraphContent"));

var _utils = require("./utils");

require("./style/TimeGraph.scss");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var xTickSize = {
  month: 105,
  day: 85,
  week: 85,
  hour: 105
};
var numberFormat = d3.format(',d');
var DEFAULT_MARGIN = {
  left: 80,
  right: 30,
  top: 50,
  bottom: 25
};
var STACK_LIMIT = 10;
var MAX_Y_AXIS_TICKS = 5;
var aggregation = {
  hour: d3.utcHour,
  day: d3.utcDay,
  week: d3.utcWeek,
  month: d3.utcMonth
};
exports.aggregation = aggregation;

var TimeGraph =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TimeGraph, _React$Component);

  function TimeGraph(props) {
    var _this;

    _classCallCheck(this, TimeGraph);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TimeGraph).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "updateDimensions", function () {
      var np = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props;

      var el = _reactDom["default"].findDOMNode(_assertThisInitialized(_this));

      var containerWidth = el.parentElement ? el.parentElement.getBoundingClientRect().width : 600;

      if (containerWidth) {
        _this.setState({
          width: np.width ? np.width : containerWidth,
          height: np.height ? np.height : Math.max(containerWidth * 0.2, 260)
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onDownload", function (fromDate, toDate, volume, dataSerie) {
      return function () {
        var dataLabel = "".concat(_this.props.timeDisplay(fromDate), "_to_").concat(_this.props.timeDisplay(toDate)).replace(/\W/gi, '');
        var defaultDimension = {
          c: 0
        };
        var stacksLabel = '';
        var delimiter = ',';
        var endLine = '\r\n';
        var keys = {};
        (0, _lodash["default"])(dataSerie).map(1).map('stack').each(function (d) {
          _lodash["default"].each(d, function (n, k) {
            keys[k] = n.name;
          });
        });

        var createLine = function createLine(name) {
          var count = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
          var stack = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
          var stacks = '';

          if (_this.props.group) {
            _lodash["default"].each(keys, function (d, i) {
              stacks += "".concat(delimiter).concat((stack[i] || defaultDimension).c);
            });
          }

          stacks += "".concat(delimiter).concat(count);
          return "".concat(name).concat(stacks).concat(endLine);
        };

        var body = (0, _lodash["default"])(dataSerie).sortBy(0).map(function (d) {
          return createLine(d[0], d[1].c, d[1].stack);
        }).join('');

        if (_this.props.group) {
          _lodash["default"].each(keys, function (d) {
            stacksLabel += "".concat(delimiter).concat(d);
          });
        }

        stacksLabel += "".concat(delimiter, "total");
        var header = "Date".concat(stacksLabel).concat(endLine);
        var fileData = header + body;
        var file = new Blob([fileData], {
          type: 'text/plain'
        });
        (0, _utils.saveData)("timeseries_".concat(dataLabel).concat(_this.props.group ? "_grouped_by_".concat(_this.props.group) : '', ".csv"), file);
      };
    });

    _defineProperty(_assertThisInitialized(_this), "toggleMetadata", function (type) {
      return function () {
        _this.setState({
          metadataFilter: Object.assign({}, _this.state.metadataFilter, _defineProperty({}, type, !_this.state.metadataFilter[type]))
        });
      };
    });

    _defineProperty(_assertThisInitialized(_this), "setP", function (range) {
      range.sort();

      _this.props.onChange(range);
    });

    _this.setP = _this.setP.bind(_assertThisInitialized(_this));
    _this.state = {
      width: 600,
      height: 260,
      comparing: false,
      metadataFilter: {
        release: false,
        experiment: false
      }
    };
    return _this;
  }

  _createClass(TimeGraph, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.updateDimensions();
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      window.addEventListener('resize', this.updateDimensions, false);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.updateDimensions);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(np) {
      this.updateDimensions(np);
    }
  }, {
    key: "lookup",
    value: function lookup(p) {
      var defaultLookup = function defaultLookup(key) {
        return key === 'null' ? '<not defined>' : key;
      };

      if (this.props.lookups && this.props.lookups[p]) {
        var lookup = this.props.lookups[p];
        return function (key) {
          return lookup[key] || defaultLookup(key);
        };
      } else return defaultLookup;
    }
  }, {
    key: "drawAxis",
    value: function drawAxis(width, height, data, margin, fromDate, toDate, xFormatter) {
      var yFormatter = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : numberFormat;
      var dateRange = [aggregation[this.props.aggregation].floor(fromDate), aggregation[this.props.aggregation].offset(toDate, this.props.type === 'bar' ? +1 : 0)];
      var maxValue = (0, _lodash["default"])(data).map('1').map('c').max();

      if (this.props.group) {
        var dimensionCount = {};

        _lodash["default"].each(data, function (d) {
          _lodash["default"].each(d[1].stack, function (b, k) {
            dimensionCount[k] = {
              key: k,
              c: dimensionCount[k] ? dimensionCount[k].c + b.c : b.c
            };
          });
        });

        var stacks = (0, _lodash["default"])(dimensionCount).sortBy('c').reverse().slice(0, STACK_LIMIT).map('key').value();

        if (this.props.type === 'line') {
          maxValue = (0, _lodash["default"])(data).map('1').map(function (d) {
            var stacksC = (0, _lodash["default"])(d.stack).mapValues('c').value();
            var stacksValue = (0, _lodash["default"])(stacksC).filter(function (d, k) {
              return stacks.indexOf(k) > -1;
            }).value();
            var otherSum = (0, _lodash["default"])(stacksC).filter(function (d, k) {
              return stacks.indexOf(k) < 0;
            }).sum();
            return (0, _lodash["default"])(stacksValue).concat(otherSum).max();
          }).max();
        }
      }

      var valueRange = [0, 1.1 * maxValue];
      var maxTicks = Math.max(2, Math.floor((width - margin.left - margin.right) / xTickSize[this.props.aggregation]) - 4);
      var x = d3.scaleTime().domain(dateRange).range([margin.left, width - margin.right]);
      var y = d3.scaleLinear().domain(valueRange).rangeRound([height - margin.bottom, margin.top]);
      var xAxis = d3.axisBottom(x).tickFormat(xFormatter).ticks(maxTicks);
      var yAxis = d3.axisLeft(y).tickFormat(yFormatter).ticks(maxValue < MAX_Y_AXIS_TICKS ? maxValue : MAX_Y_AXIS_TICKS).tickSize(-width + margin.right + margin.left);
      var lineFunc = d3.line().x(function (d) {
        return x(d[0]);
      }).y(function (d) {
        return y(d[1]);
      }).curve(d3.curveStep);
      return {
        lineFunc: lineFunc,
        scale: {
          x: x,
          y: y
        },
        axis: {
          x: xAxis,
          y: yAxis
        }
      };
    }
  }, {
    key: "preProcess",
    value: function preProcess(data, timeBounds) {
      var _this2 = this;

      return (0, _lodash["default"])(this.props.data).toPairs().map(function (p) {
        var dt = aggregation[_this2.props.aggregation]((0, _utils.dateParser)(p[0]));

        if (p[1].hasOwnProperty('c')) {
          return [dt, p[1]];
        } else {
          var c = 0;

          _lodash["default"].each(p[1], function (e, k) {
            c += e.c;
            e.name = _this2.lookup(_this2.props.group)(k);
          });

          var dimension = {
            c: c,
            stack: p[1]
          };
          return [dt, dimension];
        }
      }).filter(function (p) {
        return p[0] >= timeBounds[0];
      }).value();
    }
  }, {
    key: "getDateDomain",
    value: function getDateDomain() {
      var _this3 = this;

      var dates = (0, _lodash["default"])(this.props.data).map(function (p, k) {
        return aggregation[_this3.props.aggregation]((0, _utils.dateParser)(k));
      }).sortBy(function (dt) {
        return dt.getTime();
      }).value();
      return [dates[0], dates[dates.length - 1]];
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      if (!_lodash["default"].size(this.props.data)) {
        return _react["default"].createElement("svg", {
          width: this.state.width,
          height: this.state.height
        }, _react["default"].createElement("text", {
          x: "50%",
          y: "50%",
          alignmentBaseline: "middle",
          textAnchor: "middle"
        }, "no data to render"));
      }

      var _this$getDateDomain = this.getDateDomain(),
          _this$getDateDomain2 = _slicedToArray(_this$getDateDomain, 2),
          fromDate = _this$getDateDomain2[0],
          toDate = _this$getDateDomain2[1];

      if (this.props.toDate) {
        toDate = this.props.toDate;

        if (typeof toDate === 'number') {
          toDate = aggregation[this.props.aggregation]((0, _utils.dateParser)(toDate));
        }
      }

      if (this.props.fromDate) {
        fromDate = this.props.fromDate;

        if (typeof fromDate === 'number') {
          fromDate = aggregation[this.props.aggregation]((0, _utils.dateParser)(fromDate));
        }
      }

      var margin = Object.assign({}, DEFAULT_MARGIN, this.props.margin);
      var data = this.preProcess(this.props.data, [fromDate, toDate]);
      var graph = this.drawAxis(this.state.width, this.state.height, data, margin, fromDate, toDate, this.props.timeDisplay, this.props.countFormatter);
      var xAxis = new _reactFauxDom["default"].Element('g');
      d3.select(xAxis).attr('class', 'xaxis').attr('transform', "translate(0, ".concat(this.state.height - margin.bottom, ")")).call(graph.axis.x);
      var yAxis = new _reactFauxDom["default"].Element('g');
      d3.select(yAxis).attr('class', 'yaxis').attr('transform', "translate(".concat(margin.left, ",0)")).call(graph.axis.y);
      var range;

      if (this.props.filter) {
        range = _lodash["default"].chain(this.props.filter).map(function (v) {
          return aggregation[_this4.props.aggregation]((0, _utils.dateParser)(v));
        }).value();
      }

      var metadata = {};

      if (this.props.metadata) {
        _lodash["default"].each(this.props.metadata, function (_ref, mk) {
          var date = _ref.date,
              data = _ref.data;
          var hasData = false;
          var filteredData = {};

          _lodash["default"].each(data, function (d, k) {
            if (_this4.state.metadataFilter[d.type]) {
              hasData = true;
              filteredData[k] = d;
            }
          });

          if (hasData) {
            metadata[mk] = {
              date: date,
              data: filteredData
            };
          }
        });
      }

      return _react["default"].createElement("svg", {
        className: "time_graph",
        width: this.state.width,
        height: this.state.height
      }, _react["default"].createElement("g", {
        className: "axis"
      }, _react["default"].createElement("g", null, xAxis.toReact()), _react["default"].createElement("g", null, yAxis.toReact())), _react["default"].createElement("g", {
        onClick: this.onDownload(fromDate, toDate, this.maxValue, data)
      }, _react["default"].createElement("rect", {
        className: 'time_graph__download-button',
        width: 20,
        height: 20,
        transform: "translate(".concat(this.state.width - margin.right - 20, ", 3)")
      }), _react["default"].createElement("path", {
        className: 'time_graph__download-button__icon',
        transform: "matrix(.5 0 0 .5 ".concat(this.state.width - margin.right - 17, " 5)"),
        d: "M22.857 24q0-0.464-0.339-0.804t-0.804-0.339-0.804 0.339-0.339 0.804 0.339 0.804 0.804 0.339 0.804-0.339 0.339-0.804zM27.429 24q0-0.464-0.339-0.804t-0.804-0.339-0.804 0.339-0.339 0.804 0.339 0.804 0.804 0.339 0.804-0.339 0.339-0.804zM29.714 20v5.714q0 0.714-0.5 1.214t-1.214 0.5h-26.286q-0.714 0-1.214-0.5t-0.5-1.214v-5.714q0-0.714 0.5-1.214t1.214-0.5h8.304l2.411 2.429q1.036 1 2.429 1t2.429-1l2.429-2.429h8.286q0.714 0 1.214 0.5t0.5 1.214zM23.911 9.839q0.304 0.732-0.25 1.25l-8 8q-0.321 0.339-0.804 0.339t-0.804-0.339l-8-8q-0.554-0.518-0.25-1.25 0.304-0.696 1.054-0.696h4.571v-8q0-0.464 0.339-0.804t0.804-0.339h4.571q0.464 0 0.804 0.339t0.339 0.804v8h4.571q0.75 0 1.054 0.696z",
        fill: "#000000"
      })), this.props.metadata && _react["default"].createElement("g", {
        onClick: this.toggleMetadata('release')
      }, _react["default"].createElement("rect", {
        className: 'time_graph__metadata-button',
        width: 70,
        height: 14,
        transform: "translate(".concat(this.state.width - margin.right - 100, ", 5)")
      }), _react["default"].createElement("text", {
        className: 'time_graph__metadata-button__text',
        style: {
          textAnchor: 'left'
        },
        width: 60,
        height: 12,
        transform: "translate(".concat(this.state.width - margin.right - 94, ", 15)")
      }, this.state.metadataFilter.release ? 'Hide' : 'Show', " Releases")), "``", this.props.metadata && _react["default"].createElement("g", {
        onClick: this.toggleMetadata('experiment')
      }, _react["default"].createElement("rect", {
        className: 'time_graph__metadata-button',
        width: 80,
        height: 14,
        transform: "translate(".concat(this.state.width - margin.right - 190, ", 5)")
      }), _react["default"].createElement("text", {
        className: 'time_graph__metadata-button__text',
        style: {
          textAnchor: 'left'
        },
        width: 60,
        height: 12,
        transform: "translate(".concat(this.state.width - margin.right - 184, ", 15)")
      }, this.state.metadataFilter.experiment ? 'Hide' : 'Show', " Experiments")), _react["default"].createElement(_TimeGraphContent["default"], {
        xScale: graph.scale.x,
        yScale: graph.scale.y,
        range: range,
        timeDisplay: this.props.timeDisplay,
        aggregation: this.props.aggregation,
        onChange: this.setP,
        onClickCompare: this.props.onClickCompare,
        comparing: this.props.comparing,
        numberFormat: this.props.countFormatter || numberFormat,
        margin: margin,
        data: data,
        group: this.props.group,
        getColor: this.props.getColor,
        type: this.props.type,
        mouseIteractions: this.props.mouseIteractions,
        metadata: this.props.metadata ? metadata : null
      }));
    }
  }]);

  return TimeGraph;
}(_react["default"].Component);

exports["default"] = TimeGraph;

_defineProperty(TimeGraph, "propTypes", {
  height: _propTypes["default"].number,
  width: _propTypes["default"].number,
  data: _propTypes["default"].object,
  hideMetadata: _propTypes["default"].bool,
  metadata: _propTypes["default"].object,
  timeDisplay: _propTypes["default"].func.isRequired,
  countFormatter: _propTypes["default"].func,
  lookup: _propTypes["default"].func,
  filter: _propTypes["default"].array,
  comparing: _propTypes["default"].bool,
  onClickCompare: _propTypes["default"].any,
  onChange: _propTypes["default"].func,
  group: _propTypes["default"].string,
  type: _propTypes["default"].string,
  getColor: _propTypes["default"].func,
  aggregation: _propTypes["default"].string.isRequired,
  mouseIteractions: _propTypes["default"].bool,
  toDate: _propTypes["default"].any,
  fromDate: _propTypes["default"].any
});

_defineProperty(TimeGraph, "defaultProps", {
  mouseIteractions: true,
  type: 'bar',
  getColor: d3.scaleOrdinal(d3.schemePaired)
});