"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var d3 = _interopRequireWildcard(require("d3"));

var _lodash = require("lodash");

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _SvgLoadingAnimation = _interopRequireDefault(require("./SvgLoadingAnimation"));

var _utils = require("./utils");

require("./style/TrendingGraph.scss");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var TRIM_LENGTH = 2;

var TrendingGraph =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TrendingGraph, _React$Component);

  function TrendingGraph() {
    _classCallCheck(this, TrendingGraph);

    return _possibleConstructorReturn(this, _getPrototypeOf(TrendingGraph).apply(this, arguments));
  }

  _createClass(TrendingGraph, [{
    key: "render",
    value: function render() {
      var width = this.props.width;
      var height = this.props.height;
      var path;

      if (this.props.isLoading) {
        path = _react["default"].createElement(_SvgLoadingAnimation["default"], {
          width: width,
          height: height
        });
      } else if (this.props.data) {
        var data = (0, _lodash.sortBy)((0, _lodash.filter)((0, _lodash.toPairs)((0, _lodash.mapValues)(this.props.data, 'c')), function (val) {
          return !(0, _lodash.isUndefined)(val) && val.length === 2;
        }), 0).slice(TRIM_LENGTH, -TRIM_LENGTH);
        var maxValue = ((0, _lodash.maxBy)(data, function (e) {
          return e[1];
        }) || [])[1];
        var xAxis = d3.scaleTime().rangeRound([0, width]).domain(d3.extent(data, function (d) {
          return (0, _utils.dateParser)(d[0]);
        }));
        var yAxis = d3.scaleLinear().rangeRound([height * 0.95, height * 0.05]).domain([0, maxValue]);
        var getLine = d3.line().x(function (d) {
          return xAxis((0, _utils.dateParser)(d[0]));
        }).y(function (d) {
          return yAxis(d[1]);
        });
        var d = getLine(data);
        path = _react["default"].createElement("path", {
          d: d,
          fill: "none",
          strokeLinecap: "round",
          strokeLinejoin: "round",
          className: "trending_graph__line"
        });
      }

      return _react["default"].createElement("svg", {
        className: "trending_graph",
        viewBox: "0 0 ".concat(width, " ").concat(height),
        width: width,
        height: height
      }, path);
    }
  }]);

  return TrendingGraph;
}(_react["default"].Component);

exports["default"] = TrendingGraph;

_defineProperty(TrendingGraph, "propTypes", {
  /**
   * Dictionary of dates and values
   */
  data: _propTypes["default"].object,
  width: _propTypes["default"].number,
  height: _propTypes["default"].number,
  isLoading: _propTypes["default"].bool
});

_defineProperty(TrendingGraph, "defaultProps", {
  width: 200,
  height: 50
});