"use strict";

var _utils = require("./utils");

var _serie;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var keyValueData = {
  '1': {
    c: 16254
  },
  '2': {
    c: 37038
  }
};
var simpleData = {
  '1': {
    c: 16254
  },
  '2': {
    c: 37038
  }
};
var simpleDataReturn = {
  max: 37038,
  serie: {
    '1': {
      c: 16254,
      key: '1',
      name: '1'
    },
    '2': {
      c: 37038,
      key: '2',
      name: '2'
    }
  },
  total: 53292
};
var groupedData = {
  a: {
    '1': {
      c: 16254
    },
    '2': {
      c: 37038
    }
  },
  b: {
    '1': {
      c: 16254
    },
    '2': {
      c: 0
    }
  }
};
var groupedDataReturn = {
  max: 53292,
  serie: {
    a: {
      c: 53292,
      key: 'a',
      name: 'a',
      stack: {
        '1': {
          c: 16254,
          key: '1',
          name: '1'
        },
        '2': {
          c: 37038,
          key: '2',
          name: '2'
        }
      }
    },
    b: {
      c: 16254,
      key: 'b',
      name: 'b',
      stack: {
        '1': {
          c: 16254,
          key: '1',
          name: '1'
        },
        '2': {
          c: 0,
          key: '2',
          name: '2'
        }
      }
    }
  },
  total: 69546
};
var datedData = {
  '2017-06-13': {
    c: 16254
  },
  '2017-06-13 14': {
    c: 37038
  }
};
var datedDataReturn = {
  max: 37038,
  serie: (_serie = {}, _defineProperty(_serie, new Date('2017-06-13T00:00:00.000Z').toString(), {
    c: 16254,
    key: '2017-06-13',
    name: new Date('2017-06-13T00:00:00.000Z')
  }), _defineProperty(_serie, new Date('2017-06-13T14:00:00.000Z').toString(), {
    c: 37038,
    key: '2017-06-13 14',
    name: new Date('2017-06-13T14:00:00.000Z')
  }), _serie),
  total: 53292
};
describe('utils.normalizeData', function () {
  it('works with key-value dimension', function () {
    expect((0, _utils.normalizeData)(keyValueData)).toEqual(simpleDataReturn);
  });
  it('works with simple dimension', function () {
    expect((0, _utils.normalizeData)(simpleData)).toEqual(simpleDataReturn);
  });
  it('works with grouped dimension', function () {
    expect((0, _utils.normalizeData)(groupedData)).toEqual(groupedDataReturn);
  });
  it('works with date-based dimension', function () {
    expect((0, _utils.normalizeData)(datedData)).toEqual(datedDataReturn);
  });
});